# std::ctype_abstract_base< CharT > Class Template Reference

Common base for ctype facet. More...

`#include <locale_facets.h>`

Inheritance diagram for std::ctype_abstract_base< CharT >:

[legend]
Collaboration diagram for std::ctype_abstract_base< CharT >:

[legend]
List of all members.

## Public Types

typedef CharT | char_type
| Typedef for the template parameter.

## Public Member Functions

bool | is (mask __m, char_type c) const
| Test char_type classification.
const char_type * | is (const char_type *__lo, const char_type *__hi, mask *__vec) const
| Return a mask array.
const char_type * | scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
| Find char_type matching a mask.
const char_type * | scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
| Find char_type not matching a mask.
char_type | toupper (char_type c) const
| Convert to uppercase.
const char_type * | toupper (char_type *__lo, const char_type *__hi) const
| Convert array to uppercase.
char_type | tolower (char_type c) const
| Convert to lowercase.
const char_type * | tolower (char_type *__lo, const char_type *__hi) const
| Convert array to lowercase.
char_type | widen (char c) const
| Widen char to char_type.
const char * | widen (const char *__lo, const char *__hi, char_type *__to) const
| Widen array to char_type.
char | narrow (char_type c, char __dfault) const
| Narrow char_type to char.
const char_type * | narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
| Narrow array to char array.

## Protected Member Functions

virtual bool | do_is (mask __m, char_type c) const =0
| Test char_type classification.
virtual const char_type * | do_is (const char_type *__lo, const char_type *__hi, mask *__vec) const =0
| Return a mask array.
virtual const char_type * | do_scan_is (mask __m, const char_type *__lo, const char_type *__hi) const =0
| Find char_type matching mask.
virtual const char_type * | do_scan_not (mask __m, const char_type *__lo, const char_type *__hi) const =0
| Find char_type not matching mask.
virtual char_type | do_toupper (char_type) const =0
| Convert to uppercase.
virtual const char_type * | do_toupper (char_type *__lo, const char_type *__hi) const =0
| Convert array to uppercase.
virtual char_type | do_tolower (char_type) const =0
| Convert to lowercase.
virtual const char_type * | do_tolower (char_type *__lo, const char_type *__hi) const =0
| Convert array to lowercase.
virtual char_type | do_widen (char) const =0
| Widen char.
virtual const char * | do_widen (const char *__lo, const char *__hi, char_type *__dest) const =0
| Widen char array.
virtual char | do_narrow (char_type, char __dfault) const =0
| Narrow char_type to char.
virtual const char_type * | do_narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__dest) const =0
| Narrow char_type array to char.

## Detailed Description

### template<typename CharT>
class std::ctype_abstract_base< CharT >

Common base for ctype facet.

This template class provides implementations of the public functions that forward to the protected virtual functions.

This template also provides abtract stubs for the protected virtual functions.

Definition at line 145 of file locale_facets.h.

## Member Typedef Documentation

template<typename CharT>
typedef CharT std::ctype_abstract_base< CharT >::char_type

| Typedef for the template parameter. Reimplemented in std::ctype< CharT >. Definition at line 150 of file locale_facets.h.

## Member Function Documentation

template<typename CharT>
virtual const char_type* std::ctype_abstract_base< CharT >::do_is | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | mask * | __vec
| ) | const`[protected, pure virtual]`

Return a mask array.

This function finds the mask for each char_type in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the input.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | vec | Pointer to an array of mask storage.

Returns:
  hi.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual bool std::ctype_abstract_base< CharT >::do_is | ( | mask | __m,
|  | char_type | c
| ) | const`[protected, pure virtual]`

Test char_type classification.

This function finds a mask M for c and compares it to mask m.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters:

  | c | The char_type to find the mask of.
  | m | The mask to compare against.

Returns:
  (M & m) != 0.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual const char_type* std::ctype_abstract_base< CharT >::do_narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __dest
| ) | const`[protected, pure virtual]`

Narrow char_type array to char.

This virtual function converts each char_type in the range [lo,hi) to char using the simplest reasonable transformation and writes the results to the destination array. For any element in the input that cannot be converted, dfault is used instead.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | dfault | Char to use if conversion fails.
  | to | Pointer to the destination array.

Returns:
  hi.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual char std::ctype_abstract_base< CharT >::do_narrow | ( | char_type | ,
|  | char | __dfault
| ) | const`[protected, pure virtual]`

Narrow char_type to char.

This virtual function converts the argument to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char_type to convert.
  | dfault | Char to return if conversion fails.

Returns:
  The converted char.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual const char_type* std::ctype_abstract_base< CharT >::do_scan_is | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[protected, pure virtual]`

Find char_type matching mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is true.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  Pointer to a matching char_type if found, else hi.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual const char_type* std::ctype_abstract_base< CharT >::do_scan_not | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[protected, pure virtual]`

Find char_type not matching mask.

This function searches for and returns a pointer to the first char_type c of [lo,hi) for which is(m,c) is false.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  Pointer to a non-matching char_type if found, else hi.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual const char_type* std::ctype_abstract_base< CharT >::do_tolower | ( | char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[protected, pure virtual]`

Convert array to lowercase.

This virtual function converts each char_type in the range [lo,hi) to lowercase if possible. Other elements remain untouched.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  hi.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual char_type std::ctype_abstract_base< CharT >::do_tolower | ( | char_type |  | ) | const`[protected, pure virtual]`

Convert to lowercase.

This virtual function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters:

  | c | The char_type to convert.

Returns:
  The lowercase char_type if convertible, else c.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual const char_type* std::ctype_abstract_base< CharT >::do_toupper | ( | char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[protected, pure virtual]`

Convert array to uppercase.

This virtual function converts each char_type in the range [lo,hi) to uppercase if possible. Other elements remain untouched.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  hi.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual char_type std::ctype_abstract_base< CharT >::do_toupper | ( | char_type |  | ) | const`[protected, pure virtual]`

Convert to uppercase.

This virtual function converts the char_type argument to uppercase if possible. If not possible (for example, '2'), returns the argument.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters:

  | c | The char_type to convert.

Returns:
  The uppercase char_type if convertible, else c.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual const char* std::ctype_abstract_base< CharT >::do_widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __dest
| ) | const`[protected, pure virtual]`

Widen char array.

This function converts each char in the input to char_type using the simplest reasonable transformation.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start range.
  | hi | Pointer to end of range.
  | to | Pointer to the destination array.

Returns:
  hi.

Implemented in std::ctype< CharT >.

template<typename CharT>
virtual char_type std::ctype_abstract_base< CharT >::do_widen | ( | char |  | ) | const`[protected, pure virtual]`

Widen char.

This virtual function converts the char to char_type using the simplest reasonable transformation.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.

Returns:
  The converted char_type

Implemented in std::ctype< CharT >.

template<typename CharT>
const char_type* std::ctype_abstract_base< CharT >::is | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | mask * | __vec
| ) | const`[inline]`

Return a mask array.

This function finds the mask for each char_type in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the char array. It does so by returning the value of ctype<char_type>::do_is().

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | vec | Pointer to an array of mask storage.

Returns:
  hi.

Definition at line 180 of file locale_facets.h.

template<typename CharT>
bool std::ctype_abstract_base< CharT >::is | ( | mask | __m,
|  | char_type | c
| ) | const`[inline]`

Test char_type classification.

This function finds a mask M for c and compares it to mask m. It does so by returning the value of ctype<char_type>::do_is().

Parameters:

  | c | The char_type to compare the mask of.
  | m | The mask to compare against.

Returns:
  (M & m) != 0.

Definition at line 163 of file locale_facets.h.

template<typename CharT>
const char_type* std::ctype_abstract_base< CharT >::narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __to
| ) | const`[inline]`

Narrow array to char array.

This function converts each char_type in the input to char using the simplest reasonable transformation and writes the results to the destination array. For any char_type in the input that cannot be converted, dfault is used instead. It does so by returning ctype<char_type>::do_narrow(lo, hi, dfault, to).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | dfault | Char to use if conversion fails.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 347 of file locale_facets.h.

template<typename CharT>
char std::ctype_abstract_base< CharT >::narrow | ( | char_type | c,
|  | char | __dfault
| ) | const`[inline]`

Narrow char_type to char.

This function converts the char_type to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. It does so by returning ctype<char_type>::do_narrow(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char_type to convert.
  | dfault | Char to return if conversion fails.

Returns:
  The converted char.

Definition at line 325 of file locale_facets.h.

Referenced by std::time_get< CharT, InIter >::do_get_year(), and std::time_put< CharT, OutIter >::put().

template<typename CharT>
const char_type* std::ctype_abstract_base< CharT >::scan_is | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[inline]`

Find char_type matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is true. It does so by returning ctype<char_type>::do_scan_is().

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  Pointer to matching char_type if found, else hi.

Definition at line 196 of file locale_facets.h.

template<typename CharT>
const char_type* std::ctype_abstract_base< CharT >::scan_not | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[inline]`

Find char_type not matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is false. It does so by returning ctype<char_type>::do_scan_not().

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to first char in range.
  | hi | Pointer to end of range.

Returns:
  Pointer to non-matching char if found, else hi.

Definition at line 212 of file locale_facets.h.

template<typename CharT>
const char_type* std::ctype_abstract_base< CharT >::tolower | ( | char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[inline]`

Convert array to lowercase.

This function converts each char_type in the range [lo,hi) to lowercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_tolower(lo, hi).

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  hi.

Definition at line 270 of file locale_facets.h.

template<typename CharT>
char_type std::ctype_abstract_base< CharT >::tolower | ( | char_type | c | ) | const`[inline]`

Convert to lowercase.

This function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_tolower(c).

Parameters:

  | c | The char_type to convert.

Returns:
  The lowercase char_type if convertible, else c.

Definition at line 255 of file locale_facets.h.

template<typename CharT>
const char_type* std::ctype_abstract_base< CharT >::toupper | ( | char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[inline]`

Convert array to uppercase.

This function converts each char_type in the range [lo,hi) to uppercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_toupper(lo, hi).

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  hi.

Definition at line 241 of file locale_facets.h.

template<typename CharT>
char_type std::ctype_abstract_base< CharT >::toupper | ( | char_type | c | ) | const`[inline]`

Convert to uppercase.

This function converts the argument to uppercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_toupper().

Parameters:

  | c | The char_type to convert.

Returns:
  The uppercase char_type if convertible, else c.

Definition at line 226 of file locale_facets.h.

template<typename CharT>
const char* std::ctype_abstract_base< CharT >::widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __to
| ) | const`[inline]`

Widen array to char_type.

This function converts each char in the input to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 306 of file locale_facets.h.

template<typename CharT>
char_type std::ctype_abstract_base< CharT >::widen | ( | char | c | ) | const`[inline]`

Widen char to char_type.

This function converts the char argument to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.

Returns:
  The converted char_type.

Definition at line 287 of file locale_facets.h.

Referenced by std::money_get< CharT, InIter >::do_get(), std::time_get< CharT, InIter >::do_get_date(), std::time_get< CharT, InIter >::do_get_time(), std::time_put< CharT, OutIter >::do_put(), and std::money_put< CharT, OutIter >::do_put().

The documentation for this class was generated from the following file:

- locale_facets.h